"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _formik = require("formik");

var _react = _interopRequireWildcard(require("react"));

var _constants = require("../../public/constants");

var _async = _interopRequireDefault(require("react-select/async"));

var _axios = _interopRequireDefault(require("axios"));

var _reactSelect = _interopRequireDefault(require("react-select"));

var _patientForm = _interopRequireDefault(require("./patient-form"));

var _asyncCreatable = _interopRequireDefault(require("react-select/async-creatable"));

var _reactRedux = require("react-redux");

var _jquery = require("jquery");

var _formData = require("../../actions/formData");

var _Auth = _interopRequireDefault(require("../../helper/Auth"));

var _commonHelper = require("../../helper/commonHelper");

var _router = _interopRequireDefault(require("next/router"));

var _CancelOutlined = _interopRequireDefault(require("@material-ui/icons/CancelOutlined"));

var _fileupload = require("../../actions/fileupload");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

let config = {
  headers: {
    token: process.env.NEXT_PUBLIC_TOKEN
  }
};

const PatientDetails = props => {
  const [patientEntryType, setPatientEntryType] = (0, _react.useState)();
  const [selectedPatient, setSelectedPatient] = (0, _react.useState)(null);
  const [selectedOptionForNewPatient, setSelectedOptionForNewPatient] = (0, _react.useState)();
  const [isPatientInformationLinkSent, setIsPatientInformationLinkSent] = (0, _react.useState)();
  const [, reRender] = (0, _react.useState)();
  const [isNewPatient, setIsNewPatient] = (0, _react.useState)(false);
  const [formValues, setFormValues] = (0, _react.useState)(null);
  const [testList, setTestList] = (0, _react.useState)([]);
  const [containerId, setContainerId] = (0, _react.useState)([]);
  const [containerIdValidationList, setContainerIdValidationList] = (0, _react.useState)([]);
  const [multipleFormRef, setMultipleFormRef] = (0, _react.useState)();
  const [selectedContainerType, setSelectedContainerType] = (0, _react.useState)([]);
  const [sampleContainerList, setSampleContainerList] = (0, _react.useState)([]);
  const [containerIdErrors, showContainerIdErrors] = (0, _react.useState)(false);
  const [containerTypeErrors, showContainerTypeErrors] = (0, _react.useState)(false);
  const [pcpndtList, setPcpndtList] = (0, _react.useState)([]);
  const [collectionLocation, setCollectionLocation] = (0, _react.useState)([]);
  const [citiesAndStates, setCitiesAndStates] = (0, _react.useState)([]);
  const [pcpndtReference, setPcpndtReference] = (0, _react.useState)([]);
  const [instituteLocationRef, setInstituteLocationRef] = (0, _react.useState)([]);
  const [containers, setContainers] = (0, _react.useState)();

  const uploadPcpndtScans = (e, id) => {
    let files = [...e.target.files];
    let allowedFiles = new RegExp("application/pdf|image");
    files.map((file, id) => {
      if (file.size > 3000000) {
        const afterRemove = [...files.slice(0, id), ...files.slice(id + 1)];
        files = afterRemove;
        (0, _commonHelper.errorMessage)(file.name + " size is greater than 3mb");
      }

      if (!allowedFiles.exec(file.type)) {
        const afterRemove = [...files.slice(0, id), ...files.slice(id + 1)];
        files = afterRemove;
        (0, _commonHelper.errorMessage)(file.name + "  file type not supported");
      }
    });

    if ([...e.target.files].length > 5) {
      return (0, _commonHelper.errorMessage)("No. of Files should be less than 5");
    }

    if ([...e.target.files].length > 0) {
      if ([...pcpndtList[id].scans, ...files].length > 5) {
        (0, _commonHelper.errorMessage)("No. of Files should be less than 5 ");
        return;
      }

      console.log(e.target.files);
      pcpndtList[id].scans = [...pcpndtList[id].scans, ...files];
      pcpndtList[id].noOfFiles = pcpndtList[id].scans.length;
      pcpndtList[id].names = [...pcpndtList[id].names, e.target.files[e.target.files.length - 1].name]; // Array.from(e.target.files).forEach((test, container_id) => {
      //   pcpndtList[id].names.push(e.target.files.item(container_id).name)
      //   console.log("pcpndt scan", e.target.files.item(container_id));
      // })

      files.map(file => {
        pcpndtList[id].names.push(file.name);
      });
      console.log(id);
      console.log("PCPNDTLIST", pcpndtList);
      setPcpndtFiles(pcpndtList);
      setPcpndtList(pcpndtList);
      props.getPcpndtFiles(pcpndtList);
      console.log(pcpndtList);
      reRender({}); // reRender({});
    }
  };

  const handleRemovePcpndtScan = (test_id, id) => {
    pcpndtList[test_id].scans.splice(id, 1);
    setPcpndtList(pcpndtList);
    reRender({});
  };

  const handleUploadScansClick = async id => {
    console.log("PCPDNTREFERENCE", pcpndtReference, "ID", id);
    pcpndtReference[id].current.click();
  };

  const [isNbs, setIsNbs] = (0, _react.useState)(false);

  const setValuesOnLoad = () => {
    if (props.formDataRedux.medical_info) {
      if (props.formDataRedux.medical_info.sample_info && props.formDataRedux.medical_info.sample_info.collectionLocation.length == props.formDataRedux.test_info.selectedTests.length) {
        let asd = [];
        props.formDataRedux.medical_info.sample_info.collectionLocation.map((qwe, id) => {
          asd.push({
            city: qwe.location.city,
            state: qwe.location.state
          });
        });
        console.log(props.formValues.medical_info.sample_info.collectionLocation);
        setCollectionLocation(props.formValues.medical_info.sample_info.collectionLocation);
        reRender({});
      }

      if (props.formDataRedux.medical_info && props.formDataRedux.medical_info.sample_info) {
        setSampleContainerList(props.formDataRedux.medical_info.sample_info.sampleContainerList);
        setPcpndtList(props.fileUpload.pcpndtFiles);
        setPcpndtFiles(props.fileUpload.pcpndtFiles);
      }
    }
  };

  (0, _react.useEffect)(() => {
    console.log("PATIENT DETAILS", props);
    setValuesOnLoad();

    if (testList.length == 0) {
      getTestDetails();
    }

    setTestList(props.formValues.test_info.selectedTests);
    props.formValues.test_info.selectedTests.map(test => {
      if (test.sub_group == "NBS") {
        setIsNbs(true);
      }
    });

    if (props.patient_details && selectedPatient == null) {
      console.log("Iside if use effect");
      const patient = props.patient_details;
      setSelectedPatient(patient);
      props.getPatient_details(patient);
    } else {
      setFormValues(props.formValues);
      console.log("RE RENDERING !@!@!@!@!@@@@@@@@@@@@@~~~~~~");
      const patient = selectedPatient;
      setSelectedPatient(patient);
      props.getPatient_details(patient);
    }
  }, [selectedPatient]);

  const getTestDetails = async () => {
    let sampleContainers = [];
    let containerIdErrorsList = [];
    let containerIdValidation = [];
    let containerTypeErrorList = [];
    let containerIdList = [];
    let containerTypeList = [];
    let pcpndt_list = [];
    let pcpndtLocation = [];
    let pcpndtInputReference = [];
    let formsRef = [];
    let instituteRef = [];
    props.formValues.test_info.selectedTests.map(() => {
      sampleContainers.push({
        containers: []
      });
      containerIdErrorsList.push(false);
      containerIdValidation.push(false);
      containerTypeErrorList.push(false);
      containerIdList.push({
        value: ""
      });
      containerTypeList.push({
        value: ""
      });
      pcpndt_list.push({
        scans: [],
        names: []
      });
      pcpndtLocation.push({
        location: ""
      });
      pcpndtInputReference.push( /*#__PURE__*/(0, _react.createRef)());
      formsRef.push( /*#__PURE__*/(0, _react.createRef)());
      instituteRef.push( /*#__PURE__*/(0, _react.createRef)());
    });
    setInstituteLocationRef(instituteRef);
    setMultipleFormRef(formsRef);
    setPcpndtReference(pcpndtInputReference);
    setContainerIdValidationList(containerIdValidation);
    setContainerId(containerIdList);
    setSelectedContainerType(containerTypeList);
    setSampleContainerList(sampleContainers);
    showContainerIdErrors(containerIdErrorsList);
    showContainerTypeErrors(containerTypeErrorList);

    if (!props.formDataRedux.medical_info || props.formDataRedux.medical_info && !props.formDataRedux.medical_info.sample_info) {
      setPcpndtList(pcpndtList);
      props.getPcpndtFiles(pcpndt_list);
      setCollectionLocation(pcpndtLocation);
      setPcpndtList(pcpndt_list);
    } else {
      setPcpndtList(props.pcpndtFiles);
    }

    let sampleList = [];

    for (let i = 0; i < props.fromValues.test_info.selectedTests.length; i++) {
      const test = props.fromValues.test_info.selectedTests[i];
      sampleList.push({
        sampleType: test.sampleType,
        test_group: test.test_group
      });
    }

    let url = process.env.NEXT_PUBLIC_GET_CONTAINERS;
    const response = await (0, _Auth.default)(url, "POST", {
      samples: sampleList
    }, {
      dtrfFront: props.fromDtrfFront,
      superDtrf: props.fromSuperDtrf
    });
    const container = response.data.data.samples.map((e, i) => {
      return e.containers && e.containers.display_container_name.map((container, id) => {
        containerTypeList[i] = {
          id,
          value: container,
          label: container
        };
        setSelectedContainerType(containerTypeList);
        return {
          id,
          value: container,
          label: container
        };
      });
    });
    setContainers(container);
  };

  const handleOnClickPrevious = () => {
    props.previousStep();
    props.handleOnClickPrevious();
  };

  const handleOnClickNext = values => {
    props.handleOnClickNext("patient_details", values);
    console.log("values", values);
    console.log(123123, props.formValues.collectionLocation.location);

    if (props.formValues.collectionLocation.location != "Home") {
      props.nextStep();
      console.log(props);
    } else {
      if (props.fromSuperDtrf) {
        props.goToStep(6);
      } else if (props.fromDtrfFront) {
        props.goToStep(5);
      }

      console.log(props);
    }
  };

  const handleCytoContainerIdChange = (e, id) => {
    containerId[id].value = e.target.value;

    if (containerIdErrors[id]) {
      containerIdValidationList[id] = false;
      setContainerIdValidationList[containerIdValidationList];
    }

    if (e.target.value.length < 5 && e.target.value.length > 0) {
      containerIdValidationList[id] = true;
      setContainerIdValidationList(containerIdValidationList);
    } else {
      containerIdValidationList[id] = false;
      setContainerIdValidationList(containerIdValidationList);
    }

    setContainerId(containerId);

    if (e.target.value.length > 0) {
      containerIdErrors[id] = false;
    } else {
      containerIdErrors[id] = true;
    }

    showContainerIdErrors(containerIdErrors);
    reRender({});
  };

  const handlePatientTypeRadioButtonClick = value => {
    setPatientEntryType(value.target.value);
  };

  const handlePatientSearch = async searchString => {
    if (searchString.length > 2) {
      // const url = process.env.NEXT_PUBLIC_PATIENT_SEARCH;
      const url = "".concat(process.env.NEXT_PUBLIC_PATIENT_SEARCH, "?searchquery=").concat(searchString); // const url = `http://dtrf.aiolos.solutions:8187/v1/patient/search?searchquery=${searchString}`

      const search = {
        str: searchString
      };
      const searchedTestList = await (0, _Auth.default)(url, "GET", null, {
        superDtrf: props.fromSuperDtrf,
        dtrfFront: props.fromDtrfFront
      }); // const searchedTestList = await axios.post(url, search, config);
      // console.log(searchString);

      return searchedTestList.data.data.patientSearchList;
    }
  };

  const [contactNumber, setContactNumber] = (0, _react.useState)(null);

  const handleOnchangePatientSearch = patient => {
    setResetFields(false);
    console.log("Onchange patient search", patient);

    if (props.formValues.patient_details) {
      const data = props.formValues;
      data.patient_details = null;
      props.setFormData(data);
    }

    if (!patient.__isNew__) {
      if (selectedPatient && patient._id != selectedPatient._id) {
        console.log("Condition Working123123123123123123 ");
        const diffPatient = patient;
        getPrefilledPatientDetails(_objectSpread({}, patient));
        console.log("HANDLE ON CHANGE", patient);
        setSelectedPatient(diffPatient);
        setSelectedOptionForNewPatient(null);
        setIsNewPatient(false);
        setFormValues(patient);
        reRender({});
      } else {
        getPrefilledPatientDetails(patient);
        console.log("ITS SAMEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEeee");
        setSelectedPatient(patient);
        setSelectedOptionForNewPatient(null);
        setIsNewPatient(false);
        reRender({});
      }
    } else {
      console.log("new ", selectedOptionForNewPatient);
      setSelectedPatient("new"); // setSelectedPatient(null) 

      setSelectedOptionForNewPatient(1);
      setIsNewPatient(true);
      reRender({});
      const RegExpression = /^\d*$/;

      if (RegExpression.test(patient.label)) {
        setContactNumber(patient.label);
      }
    }
  }; // ~~~~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!! ADMIN PANEL ~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!!!!!!!!


  const handleOnClickSave = async () => {
    let sampleContainerLocation = [];
    testList.map((test, id) => {
      if (test.pcpndt) {
        const sampleValues = multipleFormRef[id].current.values;

        if (sampleValues.instituteLocation != "yes") {
          const location = {
            city: sampleValues.city ? sampleValues.city : {},
            state: sampleValues.state ? sampleValues.state : {},
            address: sampleValues.address,
            pinCode: sampleValues.pinCode,
            id: props.formDataRedux.test_info.selectedTests[id]._id
          };
          sampleContainerLocation.push({
            location
          });
        } else {
          if (sampleValues.instituteLocation == "yes") {
            const location = {
              institute: "Institute"
            };
            sampleContainerLocation.push({
              location
            });
          }
        }
      } else {
        sampleContainerLocation.push({
          location: ""
        });
      }
    });
    multipleFormRef.map(ref => {
      ref.current.handleSubmit();
    });
    const sample_info = {};
    sample_info = {
      sampleContainerList,
      collectionLocation: sampleContainerLocation,
      pcpndtList: props.fileUpload.pcpndtFiles
    };
    let data = {};
    let formData = new FormData();
    data.dtrf_id = props.Token.dtrfToken;
    data.dtrf = props.formDataRedux;
    data.dtrf.medical_info.sample_info = sample_info;

    if (data.dtrf.patient_details) {
      delete data.dtrf.patient_details;
    }

    const response = await props.handleOnClickSave(_objectSpread({}, data.dtrf));
    props.setFormData(_objectSpread({}, data.dtrf));

    if (response) {
      if (response.status == 200) {
        (0, _commonHelper.successMessage)("Form saved");
      }
    } else {
      return (0, _commonHelper.errorMessage)("Error in Saving Form");
    }
  };

  const handleOnClickSaveAndExit = async () => {
    await handleOnClickSave();

    _router.default.push("/super-dtrf");
  };

  const handleOnClickTest = () => {
    props.nextStep();
  }; // ~~~~~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!! ADMIN PANEL CLOSE~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!!!!!
  // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PRefilled Patient ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


  const [selectedCity, setSelectedCity] = (0, _react.useState)("");
  const [selectedState, setSelectedState] = (0, _react.useState)("");

  const getPrefilledPatientDetails = data => {
    console.log("Insite getPRefilledPatientDetails");

    if (data) {
      if (!data.isNew) {
        setPrefilledPatient(data);
        setSelectedPatient(data);
        setSelectedOptionForNewPatient(null);
        setIsNewPatient(false);
        reRender({});
      } else {
        setPrefilledPatient(data);
        setSelectedOptionForNewPatient(1);
        setIsNewPatient(true);
      }
    }
  };

  const [resetFields, setResetFields] = (0, _react.useState)(true);
  const [prefilledPatient, setPrefilledPatient] = (0, _react.useState)({});
  const [prefilledPatientLabel, setPrefilledPatientLabel] = (0, _react.useState)(); // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~CLOSE Prefilled Patient CLOSE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

  const handleOnChangeOptionForNewPatient = option => {
    setSelectedOptionForNewPatient(option.target.value);
  };

  const handleSendLinkMedicalForm = () => {
    setIsPatientInformationLinkSent(true);
  };

  const handleCreateNewPatient = e => {
    console.log("create new");
  };

  const promiseOptions = async inputValue => new Promise(resolve => {
    resolve(handlePatientSearch(inputValue));
  });

  console.log(selectedPatient, "Selected patient");
  return /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "customWrap"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "row"
  }, props.fromSuperDtrf && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
    className: "col-md-12 col-12 text-right"
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      padding: "10px 0px"
    }
  }, !props.Token.isComplete && /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    onClick: () => handleOnClickSaveAndExit(),
    className: "btn btn-primary mr-2"
  }, "Save And Exit")))), /*#__PURE__*/_react.default.createElement("div", {
    className: "col-md-12 col-12"
  }, /*#__PURE__*/_react.default.createElement("fieldset", {
    id: "valdatinStep1"
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("label", null, "Enter Phone No. / Name"), /*#__PURE__*/_react.default.createElement("div", {
    className: "form-group"
  }, /*#__PURE__*/_react.default.createElement(_asyncCreatable.default, {
    defaultOptions: true,
    loadOptions: promiseOptions,
    onChange: handleOnchangePatientSearch,
    getOptionLabel: e => {
      if (e.name) {
        if (e.mothersName) {
          if (e.hasBabyName) {
            return e.name.firstName + " " + e.name.lastName + " | " + e.contact;
          } else {
            return "Baby of " + e.name.firstName + " " + e.name.lastName + " | " + e.contact;
          }
        } else {
          return e.name.firstName + " " + e.name.lastName + " | " + e.contact;
        }
      } else {
        return "Create New";
      }
    }
  })), selectedPatient && selectedPatient != "new" && /*#__PURE__*/_react.default.createElement(_patientForm.default, {
    fromSuperDtrf: props.fromSuperDtrf,
    fromDtrfFront: props.fromDtrfFront,
    resetFields: resetFields,
    setResetFields: setResetFields,
    handleOnClickPrevious: handleOnClickPrevious,
    handleOnClickNext: handleOnClickNext,
    patient: prefilledPatient,
    editable: true,
    new: selectedPatient.isNew ? true : false,
    formValues: props.formValues,
    contactNumber: contactNumber,
    handleOnClickSave: props.handleOnClickSave
  }), selectedOptionForNewPatient == 1 && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_patientForm.default, {
    handleOnClickSave: props.handleOnClickSave,
    fromSuperDtrf: props.fromSuperDtrf,
    fromDtrfFront: props.fromDtrfFront,
    resetFields: resetFields,
    setResetFields: setResetFields,
    patient: selectedPatient,
    handleOnClickPrevious: handleOnClickPrevious,
    previousStep: props.previousStep,
    handleOnClickNext: handleOnClickNext,
    new: true,
    formValues: props.formValues,
    contactNumber: contactNumber
  })))))), /*#__PURE__*/_react.default.createElement("div", {
    className: "row"
  }, /*#__PURE__*/_react.default.createElement("hr", null), /*#__PURE__*/_react.default.createElement("h4", null, "Sample Info"), /*#__PURE__*/_react.default.createElement("hr", null), containers && testList.map((test, id) =>
  /*#__PURE__*/
  // testList.map((test, id) => (
  _react.default.createElement("div", {
    className: "customWrap mb-2"
  }, /*#__PURE__*/_react.default.createElement("div", null, /*#__PURE__*/_react.default.createElement("h6", null, test.test_name)), /*#__PURE__*/_react.default.createElement(_formik.Formik, {
    innerRef: multipleFormRef[id],
    initialValues: {
      address: collectionLocation ? collectionLocation[id].location.address : "",
      pinCode: collectionLocation ? collectionLocation[id].location.pinCode : "",
      instituteLocation: collectionLocation && collectionLocation[id].location.hasOwnProperty("institute") ? ["yes"] : "",
      city: collectionLocation ? collectionLocation[id].location.city : "",
      state: collectionLocation ? collectionLocation[id].location.state : ""
    },
    validate: values => {
      const errors = {};

      if (props.fromDtrfFront) {
        if (test.pcpndt) {
          if (values.instituteLocation != 'yes') {
            if (!values.address) {
              errors.address = "Required";
            }

            if (!values.pinCode) {
              errors.pinCode = "Required";
            } else if (!Number(values.pinCode)) {
              errors.pinCode = "Should be Number";
            }

            if (!values.city) {
              errors.city = "Reqruied";
            }

            if (!values.state) {
              errors.state = "Required";
            }
          }
        }
      }

      return errors;
    },
    onSubmit: (values, _ref) => {
      let {
        setSubmitting
      } = _ref;

      if (test.pcpndt) {
        if (values.instituteLocation != "yes") {
          const location = {
            city: values.city,
            state: values.state,
            address: values.address,
            pinCode: values.pinCode,
            id: props.formValues.test_info.selectedTests[id]._id
          };
          collectionLocation[id].location = location;
          setCollectionLocation(collectionLocation);
        } else {
          const location = {
            institute: "Institute"
          };
          collectionLocation[id].location = location;
        }
      }
    }
  }, _ref2 => {
    let {
      values
    } = _ref2;
    return /*#__PURE__*/_react.default.createElement(_formik.Form, null, /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "row"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "col-12 col-md-6 form-group"
    }, /*#__PURE__*/_react.default.createElement("label", null, "Sample Container Id", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*")), /*#__PURE__*/_react.default.createElement("input", {
      type: "text",
      name: id,
      value: containerId[id].value,
      placeholder: "Enter Sample Container id (minimum 5 characters)",
      className: "form-control",
      onChange: value => handleCytoContainerIdChange(value, id)
    }), containerIdErrors[id] && /*#__PURE__*/_react.default.createElement("div", {
      className: "formErr"
    }, "Required"), containerIdValidationList[id] && /*#__PURE__*/_react.default.createElement("div", {
      className: "formErr"
    }, "Id should have more than 4 characters ")), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-8 col-md-4 form-group"
    }, /*#__PURE__*/_react.default.createElement("label", null, "Sample Container Type", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*")), containers[id] ? /*#__PURE__*/_react.default.createElement(_reactSelect.default, {
      name: id,
      getOptionLabel: e => "".concat(e.label),
      getOptionValue: e => "".concat(e.value),
      options: containers[id],
      value: selectedContainerType[id],
      onChange: value => handleContainerTypeChange(value, id),
      name: "referenceDoctorState"
    }) : /*#__PURE__*/_react.default.createElement("label", null, "Containers Not Found"), /*#__PURE__*/_react.default.createElement(_formik.ErrorMessage, {
      name: "sampleContainerType",
      component: "div",
      className: "formErr"
    }), containerTypeErrors[id] && /*#__PURE__*/_react.default.createElement("div", {
      className: "formErr"
    }, "Required")), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-4 col-md-2 form-group"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "row mt-1"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "col-md-12 col-12 text-left mt-4"
    }, /*#__PURE__*/_react.default.createElement("button", {
      name: id,
      type: "button",
      className: "btn btn-primary",
      onClick: () => handleCytoAddContainerID(id)
    }, "Add")))), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-10 col-md-8 form-group"
    }, sampleContainerList[id].containers.map((test, container_id) => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "row mb-1"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "col-10"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "form-group mb-0"
    }, /*#__PURE__*/_react.default.createElement("label", {
      className: "form-control",
      style: {
        height: "auto"
      }
    }, test.type, ": ", test.id))), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-2  text-left"
    }, /*#__PURE__*/_react.default.createElement("div", {
      style: {
        padding: "5px 20px"
      }
    }, /*#__PURE__*/_react.default.createElement("button", {
      name: id,
      type: "button",
      className: "btn btn-primary",
      onClick: () => handleCytoRemoveContainerId(id, container_id)
    }, "remove")))))))), test.pcpndt && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("h6", null, "PCPNDT Info"), /*#__PURE__*/_react.default.createElement("hr", null), /*#__PURE__*/_react.default.createElement("div", {
      className: "mb-3"
    }, /*#__PURE__*/_react.default.createElement("input", {
      type: "file",
      ref: pcpndtReference[id],
      accept: "image/*,application/pdf",
      style: {
        display: 'none'
      },
      className: "form-control",
      onChange: files => uploadPcpndtScans(files, id),
      multiple: true
    })), /*#__PURE__*/_react.default.createElement("div", {
      className: "row"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "col-md-6 col-12"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "form-group",
      style: {
        display: "flex"
      }
    }, /*#__PURE__*/_react.default.createElement(_formik.Field, {
      ref: instituteLocationRef[id],
      type: "checkbox",
      name: "instituteLocation",
      value: "yes"
    }), /*#__PURE__*/_react.default.createElement("label", {
      className: "mb-3 ml-3"
    }, "Sample pickup location is same as institute location ", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*")), /*#__PURE__*/_react.default.createElement("br", null), /*#__PURE__*/_react.default.createElement(_formik.ErrorMessage, {
      name: "instituteLocation",
      component: "div",
      className: "formErr"
    })))), /*#__PURE__*/_react.default.createElement("div", {
      className: "row"
    }, /*#__PURE__*/_react.default.createElement("label", null, "Location ", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*"))), /*#__PURE__*/_react.default.createElement("div", {
      className: "row"
    }, /*#__PURE__*/_react.default.createElement(TextField, {
      title: "Address",
      name: "address",
      mandatory: true,
      component: "textarea",
      isDisabled: values.instituteLocation == "yes" ? true : false
    }), /*#__PURE__*/_react.default.createElement(TextField, {
      title: "Pin Code",
      name: "pinCode",
      mandatory: true,
      isDisabled: values.instituteLocation == "yes" ? true : false
    }), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-md-6 col-12"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "form-group"
    }, /*#__PURE__*/_react.default.createElement("label", null, "City ", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*")), /*#__PURE__*/_react.default.createElement(MySelect, {
      isMulti: false,
      optionList: cityList,
      name: "city",
      isDisabled: values.instituteLocation == 'yes' ? true : false
    }), /*#__PURE__*/_react.default.createElement(_formik.ErrorMessage, {
      name: "city",
      component: "div",
      className: "formErr"
    }))), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-md-6 col-12"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "form-group"
    }, /*#__PURE__*/_react.default.createElement("label", null, "State ", /*#__PURE__*/_react.default.createElement("span", {
      className: "marked"
    }, "*")), /*#__PURE__*/_react.default.createElement(MySelect, {
      isMulti: false,
      optionList: stateList,
      name: "state",
      isDisabled: values.instituteLocation == 'yes' ? true : false
    }), /*#__PURE__*/_react.default.createElement(_formik.ErrorMessage, {
      name: "state",
      component: "div",
      className: "formErr"
    }))), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-4 col-md-4 form-group"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "row mt-1"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "text-right mt-4"
    }, /*#__PURE__*/_react.default.createElement("button", {
      htmlFor: "files",
      type: "button",
      className: "btn btn-primary",
      onClick: () => handleUploadScansClick(id)
    }, "Upload Scans"))))), /*#__PURE__*/_react.default.createElement("div", {
      className: "col-10 col-md-8 form-group"
    }, props.fileUpload.pcpndtFiles[id].scans.map((name, container_id) => /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("div", {
      className: "row mb-1"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "col-10"
    }, /*#__PURE__*/_react.default.createElement("div", {
      className: "form-control mb-0"
    }, /*#__PURE__*/_react.default.createElement("svg", {
      xmlns: "http://www.w3.org/2000/svg",
      width: "24",
      height: "24",
      viewBox: "0 0 24 24",
      fill: "none",
      stroke: "currentColor",
      "stroke-width": "2",
      "stroke-linecap": "round",
      "stroke-linejoin": "round",
      class: "feather feather-file"
    }, /*#__PURE__*/_react.default.createElement("path", {
      d: "M13 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V9z"
    }), /*#__PURE__*/_react.default.createElement("polyline", {
      points: "13 2 13 9 20 9"
    })), /*#__PURE__*/_react.default.createElement("label", {
      className: "ml-2",
      style: {
        fontSize: "12px"
      }
    }, name.name ? name.name : name.displayName ? name.displayName : name.originalname))), /*#__PURE__*/_react.default.createElement(_CancelOutlined.default, {
      size: "medium",
      onClick: e => onRemovePcpndt(id, container_id)
    }))))))));
  })))), props.fromSuperDtrf && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !selectedPatient && selectedOptionForNewPatient != 1 && /*#__PURE__*/_react.default.createElement("div", {
    className: "row"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "col-md-2 col-2 text-left"
  }, /*#__PURE__*/_react.default.createElement("div", {
    style: {
      padding: "5px 20px"
    }
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: e => _router.default.push("/super-dtrf"),
    className: "btn btn-primary mr-2"
  }, "Exit"))), /*#__PURE__*/_react.default.createElement("div", {
    className: "col-md-10 col-6 text-reft "
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "formButttonCenter"
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleOnClickPrevious,
    className: "btn btn-primary mr-2"
  }, "Previous"), !props.Token.isComplete && /*#__PURE__*/_react.default.createElement("button", {
    type: "button",
    onClick: () => handleOnClickSave(),
    className: "btn btn-primary mr-2"
  }, "Save"), /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleOnClickTest,
    className: "btn btn-primary mr-2"
  }, "Next"))))), props.fromDtrfFront && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, !selectedPatient && selectedOptionForNewPatient != 1 && /*#__PURE__*/_react.default.createElement("div", {
    className: "row"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "col-md-12 col-12 text-right"
  }, /*#__PURE__*/_react.default.createElement("div", {
    className: "formButttonCenter"
  }, /*#__PURE__*/_react.default.createElement("button", {
    onClick: handleOnClickPrevious,
    className: "btn btn-primary mr-2"
  }, "Previous")))))));
};

const mapStateToProps = state => ({
  patient_details: state.formData.formData.patient_details ? state.formData.formData.patient_details : null,
  formDataRedux: state.formData.formData,
  Token: state.Token
});

var _default = (0, _reactRedux.connect)(mapStateToProps, {
  getPatient_details: _formData.getPatient_details,
  setFormData: _formData.setFormData,
  getPcpndtFiles: _fileupload.getPcpndtFiles
})(PatientDetails);

exports.default = _default;