import { Formik, Form, Field, ErrorMessage } from "formik";
import React, { useState, useEffect, createRef } from "react";
import { patients } from "../../public/constants";
import AsyncSelect from "react-select/async";
import axios from "axios";
import Select from "react-select";
import PatientForm from "./patient-form";
import AsyncCreatableSelect from 'react-select/async-creatable';
import { connect } from "react-redux";
import { data } from "jquery";
import { getPatient_details, setFormData } from "../../actions/formData";
import reqWithToken from "../../helper/Auth";
import { successMessage, MousePopover, errorMessage, warningMessage, infoMessage } from "../../helper/commonHelper";
import Router from "next/router";
import CancelOutlinedIcon from '@material-ui/icons/CancelOutlined';
import { getPcpndtFiles } from "../../actions/fileupload";


let config = {
  headers: {
    token: process.env.NEXT_PUBLIC_TOKEN,
  },
};

const PatientDetails = (props) => {
  const [patientEntryType, setPatientEntryType] = useState();
  const [selectedPatient, setSelectedPatient] = useState(null);
  const [
    selectedOptionForNewPatient,
    setSelectedOptionForNewPatient,
  ] = useState();
  const [
    isPatientInformationLinkSent,
    setIsPatientInformationLinkSent,
  ] = useState();
  const [, reRender] = useState();
  const [isNewPatient, setIsNewPatient] = useState(false)
  const [formValues, setFormValues] = useState(null)



  const [testList, setTestList] = useState([])
  const [containerId, setContainerId] = useState([]);
  const [containerIdValidationList, setContainerIdValidationList] = useState([])
  const [multipleFormRef, setMultipleFormRef] = useState()
  const [selectedContainerType, setSelectedContainerType] = useState([]);
  const [sampleContainerList, setSampleContainerList] = useState([]);
  const [containerIdErrors, showContainerIdErrors] = useState(false)
  const [containerTypeErrors, showContainerTypeErrors] = useState(false)
  const [pcpndtList, setPcpndtList] = useState([])
  const [collectionLocation, setCollectionLocation] = useState([])
  const [citiesAndStates, setCitiesAndStates] = useState([])
  const [pcpndtReference, setPcpndtReference] = useState([])
  const [instituteLocationRef, setInstituteLocationRef] = useState([])
  const [containers, setContainers] = useState()

  const uploadPcpndtScans = (e, id) => {
    let files = [...e.target.files]
    let allowedFiles = new RegExp("application/pdf|image");
    files.map((file, id) => {
      if (file.size > 3000000) {
        const afterRemove = [...files.slice(0, id), ...files.slice(id + 1)]
        files = afterRemove
        errorMessage(file.name + " size is greater than 3mb")
      }
      if (!allowedFiles.exec(file.type)) {
        const afterRemove = [...files.slice(0, id), ...files.slice(id + 1)]
        files = afterRemove
        errorMessage(file.name + "  file type not supported")
      }
    })

    if ([...e.target.files].length > 5) {
      return errorMessage("No. of Files should be less than 5")
    }


    if ([...e.target.files].length > 0) {
      if ([...pcpndtList[id].scans, ...files].length > 5) {
        errorMessage("No. of Files should be less than 5 ")
        return
      }
      console.log(e.target.files)

      pcpndtList[id].scans = [...pcpndtList[id].scans, ...files]
      pcpndtList[id].noOfFiles = pcpndtList[id].scans.length
      pcpndtList[id].names = [...pcpndtList[id].names, e.target.files[e.target.files.length - 1].name]
      // Array.from(e.target.files).forEach((test, container_id) => {
      //   pcpndtList[id].names.push(e.target.files.item(container_id).name)

      //   console.log("pcpndt scan", e.target.files.item(container_id));
      // })
      files.map((file) => {
        pcpndtList[id].names.push(file.name)
      })
      console.log(id)
      console.log("PCPNDTLIST", pcpndtList)
      setPcpndtFiles(pcpndtList)
      setPcpndtList(pcpndtList)
      props.getPcpndtFiles(pcpndtList)
      console.log(pcpndtList);
      reRender({});
      // reRender({});
    }
  }
  const handleRemovePcpndtScan = (test_id, id) => {
    pcpndtList[test_id].scans.splice(id, 1);
    setPcpndtList(pcpndtList)
    reRender({});
  }

  const handleUploadScansClick = async (id) => {
    console.log("PCPDNTREFERENCE", pcpndtReference, "ID", id)
    pcpndtReference[id].current.click();
  }

  const [isNbs, setIsNbs] = useState(false)
  const setValuesOnLoad = () => {
    if (props.formDataRedux.medical_info) {
      if (props.formDataRedux.medical_info.sample_info && (props.formDataRedux.medical_info.sample_info.collectionLocation.length == props.formDataRedux.test_info.selectedTests.length)) {
        let asd = []
        props.formDataRedux.medical_info.sample_info.collectionLocation.map((qwe, id) => {
          asd.push({ city: qwe.location.city, state: qwe.location.state })
        })
        console.log(props.formValues.medical_info.sample_info.collectionLocation)
        setCollectionLocation(props.formValues.medical_info.sample_info.collectionLocation)
        reRender({})
      }
      if (props.formDataRedux.medical_info && props.formDataRedux.medical_info.sample_info) {
        setSampleContainerList(props.formDataRedux.medical_info.sample_info.sampleContainerList)
        setPcpndtList(props.fileUpload.pcpndtFiles)
        setPcpndtFiles(props.fileUpload.pcpndtFiles)
      }

    }
  }

  useEffect(() => {
    console.log("PATIENT DETAILS", props)
    setValuesOnLoad()
    if (testList.length == 0) {
      getTestDetails()
    }
    setTestList(props.formValues.test_info.selectedTests)
    props.formValues.test_info.selectedTests.map((test) => {
      if (test.sub_group == "NBS") {
        setIsNbs(true)
      }
    })
    if (props.patient_details && selectedPatient == null) {


      console.log("Iside if use effect")
      const patient = props.patient_details
      setSelectedPatient(patient)
      props.getPatient_details(patient)

    } else {

      setFormValues(props.formValues)
      console.log("RE RENDERING !@!@!@!@!@@@@@@@@@@@@@~~~~~~")
      const patient = selectedPatient
      setSelectedPatient(patient)
      props.getPatient_details(patient)
    }
  }, [selectedPatient]);

  const getTestDetails = async () => {
    let sampleContainers = [];
    let containerIdErrorsList = [];
    let containerIdValidation = []
    let containerTypeErrorList = [];
    let containerIdList = [];
    let containerTypeList = [];
    let pcpndt_list = []
    let pcpndtLocation = []
    let pcpndtInputReference = []
    let formsRef = []
    let instituteRef = []
    props.formValues.test_info.selectedTests.map(() => {
      sampleContainers.push({ containers: [] })
      containerIdErrorsList.push(false)
      containerIdValidation.push(false)
      containerTypeErrorList.push(false)
      containerIdList.push({ value: "" })
      containerTypeList.push({ value: "" })
      pcpndt_list.push({ scans: [], names: [] })
      pcpndtLocation.push({ location: "" })
      pcpndtInputReference.push(createRef())
      formsRef.push(createRef())
      instituteRef.push(createRef())
    })
    setInstituteLocationRef(instituteRef)
    setMultipleFormRef(formsRef)
    setPcpndtReference(pcpndtInputReference)
    setContainerIdValidationList(containerIdValidation)
    setContainerId(containerIdList)
    setSelectedContainerType(containerTypeList)
    setSampleContainerList(sampleContainers)
    showContainerIdErrors(containerIdErrorsList)
    showContainerTypeErrors(containerTypeErrorList)
    if (!props.formDataRedux.medical_info || (props.formDataRedux.medical_info && !props.formDataRedux.medical_info.sample_info)) {

      setPcpndtList(pcpndtList)
      props.getPcpndtFiles(pcpndt_list)
      setCollectionLocation(pcpndtLocation)
      setPcpndtList(pcpndt_list)
    } else {
      setPcpndtList(props.pcpndtFiles)
    }

    let sampleList = []
    for (let i = 0; i < props.fromValues.test_info.selectedTests.length; i++) {
      const test = props.fromValues.test_info.selectedTests[i];
      sampleList.push({ sampleType: test.sampleType, test_group: test.test_group })
    }
    let url = process.env.NEXT_PUBLIC_GET_CONTAINERS
    const response = await reqWithToken(url, "POST", { samples: sampleList }, { dtrfFront: props.fromDtrfFront, superDtrf: props.fromSuperDtrf })
    const container = response.data.data.samples.map((e, i) => {
      return e.containers && e.containers.display_container_name.map((container, id) => {
        containerTypeList[i] = { id, value: container, label: container }
        setSelectedContainerType(containerTypeList)
        return { id, value: container, label: container }
      })
    })
    setContainers(container)
  }

  const handleOnClickPrevious = () => {

    props.previousStep();
    props.handleOnClickPrevious();
  };

  const handleOnClickNext = (values) => {

    props.handleOnClickNext("patient_details", values);
    console.log("values", values)
    console.log(123123, props.formValues.collectionLocation.location);
    if (props.formValues.collectionLocation.location != "Home") {
      props.nextStep();
      console.log(props);
    } else {
      if (props.fromSuperDtrf) {
        props.goToStep(6)
      } else if (props.fromDtrfFront) {
        props.goToStep(5);
      }
      console.log(props);
    }
  };
  const handleCytoContainerIdChange = (e, id) => {
    containerId[id].value = e.target.value
    if (containerIdErrors[id]) {
      containerIdValidationList[id] = false
      setContainerIdValidationList[containerIdValidationList]
    }
    if (e.target.value.length < 5 && e.target.value.length > 0) {
      containerIdValidationList[id] = true
      setContainerIdValidationList(containerIdValidationList)
    } else {
      containerIdValidationList[id] = false
      setContainerIdValidationList(containerIdValidationList)
    }
    setContainerId(containerId);
    if (e.target.value.length > 0) {
      containerIdErrors[id] = false
    } else {
      containerIdErrors[id] = true
    }
    showContainerIdErrors(containerIdErrors)
    reRender({});
  };

  const handlePatientTypeRadioButtonClick = (value) => {
    setPatientEntryType(value.target.value);
  };

  const handlePatientSearch = async (searchString) => {


    if (searchString.length > 2) {
      // const url = process.env.NEXT_PUBLIC_PATIENT_SEARCH;
      const url = `${process.env.NEXT_PUBLIC_PATIENT_SEARCH}?searchquery=${searchString}`
      // const url = `http://dtrf.aiolos.solutions:8187/v1/patient/search?searchquery=${searchString}`
      const search = { str: searchString };
      const searchedTestList = await reqWithToken(url, "GET", null, { superDtrf: props.fromSuperDtrf, dtrfFront: props.fromDtrfFront })
      // const searchedTestList = await axios.post(url, search, config);
      // console.log(searchString);

      return searchedTestList.data.data.patientSearchList;
    }


  };


  const [contactNumber, setContactNumber] = useState(null)
  const handleOnchangePatientSearch = (patient) => {
    setResetFields(false)
    console.log("Onchange patient search", patient)
    if (props.formValues.patient_details) {
      const data = props.formValues
      data.patient_details = null
      props.setFormData(data)
    }
    if (!patient.__isNew__) {
      if (selectedPatient && patient._id != selectedPatient._id) {
        console.log("Condition Working123123123123123123 ")
        const diffPatient = patient
        getPrefilledPatientDetails({ ...patient })
        console.log("HANDLE ON CHANGE", patient)
        setSelectedPatient(diffPatient);
        setSelectedOptionForNewPatient(null)
        setIsNewPatient(false)
        setFormValues(patient)

        reRender({})
      } else {
        getPrefilledPatientDetails(patient)
        console.log("ITS SAMEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEEeee")
        setSelectedPatient(patient);
        setSelectedOptionForNewPatient(null)
        setIsNewPatient(false)

        reRender({})
      }


    } else {
      console.log("new ", selectedOptionForNewPatient);
      setSelectedPatient("new");
      // setSelectedPatient(null) 
      setSelectedOptionForNewPatient(1)
      setIsNewPatient(true)
      reRender({})
      const RegExpression = /^\d*$/
      if (RegExpression.test(patient.label)) {

        setContactNumber(patient.label)
      }
    }
  };

  // ~~~~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!! ADMIN PANEL ~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!!!!!!!!
  const handleOnClickSave = async () => {
    let sampleContainerLocation = []
    testList.map((test, id) => {
      if (test.pcpndt) {
        const sampleValues = multipleFormRef[id].current.values

        if (sampleValues.instituteLocation != "yes") {
          const location = {
            city: sampleValues.city ? sampleValues.city : {},
            state: sampleValues.state ? sampleValues.state : {},
            address: sampleValues.address,
            pinCode: sampleValues.pinCode,
            id: props.formDataRedux.test_info.selectedTests[id]._id
          }
          sampleContainerLocation.push({ location })
        } else {
          if (sampleValues.instituteLocation == "yes") {
            const location = { institute: "Institute" }
            sampleContainerLocation.push({ location })
          }
        }
      } else {
        sampleContainerLocation.push({ location: "" })
      }
    })

    multipleFormRef.map((ref) => {
      ref.current.handleSubmit()
    })
    const sample_info = {}
    sample_info = {
      sampleContainerList, collectionLocation: sampleContainerLocation, pcpndtList: props.fileUpload.pcpndtFiles
    }
    let data = {}
    let formData = new FormData()
    data.dtrf_id = props.Token.dtrfToken
    data.dtrf = props.formDataRedux
    data.dtrf.medical_info.sample_info = sample_info
    if (data.dtrf.patient_details) {
      delete data.dtrf.patient_details
    }
    const response = await props.handleOnClickSave({ ...data.dtrf })
    props.setFormData({ ...data.dtrf })
    if (response) {

      if (response.status == 200) {
        successMessage("Form saved")
      }
    } else {
      return errorMessage("Error in Saving Form")
    }

  }

  const handleOnClickSaveAndExit = async () => {
    await handleOnClickSave();
    Router.push("/super-dtrf")
  }

  const handleOnClickTest = () => {
    props.nextStep();
  }
  // ~~~~~~~~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!! ADMIN PANEL CLOSE~~~~~~~~~~~~~~~!!!!!!!!!!!!!!!!!!!
  // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PRefilled Patient ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


  const [selectedCity, setSelectedCity] = useState("")
  const [selectedState, setSelectedState] = useState("")


  const getPrefilledPatientDetails = (data) => {
    console.log("Insite getPRefilledPatientDetails")
    if (data) {
      if (!data.isNew) {
        setPrefilledPatient(data)
        setSelectedPatient(data);
        setSelectedOptionForNewPatient(null)
        setIsNewPatient(false)
        reRender({})
      }
      else {
        setPrefilledPatient(data)
        setSelectedOptionForNewPatient(1)
        setIsNewPatient(true)
      }

    }
  }
  const [resetFields, setResetFields] = useState(true)
  const [prefilledPatient, setPrefilledPatient] = useState({})
  const [prefilledPatientLabel, setPrefilledPatientLabel] = useState()
  // ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~CLOSE Prefilled Patient CLOSE~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  const handleOnChangeOptionForNewPatient = (option) => {
    setSelectedOptionForNewPatient(option.target.value);
  };

  const handleSendLinkMedicalForm = () => {
    setIsPatientInformationLinkSent(true);
  };

  const handleCreateNewPatient = (e) => {
    console.log("create new");
  }

  const promiseOptions = async inputValue =>
    new Promise(resolve => {
      resolve(handlePatientSearch(inputValue));
    });
  console.log(selectedPatient, "Selected patient")
  return (
    <>
      <div className="customWrap">
        <div className="row">
          {
            props.fromSuperDtrf && <>
              <div className="col-md-12 col-12 text-right">
                <div style={{ padding: "10px 0px" }}>
                  {!props.Token.isComplete &&

                    <button
                      type="button"
                      onClick={() =>
                        handleOnClickSaveAndExit()
                      }
                      className="btn btn-primary mr-2"
                    >
                      Save And Exit
                    </button>
                  }
                </div>
              </div>
            </>
          }
          <div className="col-md-12 col-12">
            <fieldset id="valdatinStep1">

              {/* {patientEntryType == 2 && ( */}
              <div>
                <label>Enter Phone No. / Name</label>

                <div className="form-group">
                  <AsyncCreatableSelect
                    defaultOptions

                    loadOptions={promiseOptions}
                    onChange={handleOnchangePatientSearch}
                    getOptionLabel={(e) => {
                      if (e.name) {
                        if (e.mothersName) {
                          if (e.hasBabyName) {
                            return e.name.firstName + " " + e.name.lastName + " | " + e.contact
                          } else {
                            return "Baby of " + e.name.firstName + " " + e.name.lastName + " | " + e.contact
                          }
                        } else {
                          return e.name.firstName + " " + e.name.lastName + " | " + e.contact
                        }
                      } else {
                        return "Create New"
                      }
                    }

                    }
                  />
                </div>
                {selectedPatient && selectedPatient != "new" && (
                  <PatientForm
                    fromSuperDtrf={props.fromSuperDtrf}
                    fromDtrfFront={props.fromDtrfFront}
                    resetFields={resetFields}
                    setResetFields={setResetFields}
                    handleOnClickPrevious={handleOnClickPrevious}
                    handleOnClickNext={handleOnClickNext}
                    patient={prefilledPatient}
                    editable={true}
                    new={selectedPatient.isNew ? true : false}
                    formValues={props.formValues}
                    contactNumber={contactNumber}
                    handleOnClickSave={props.handleOnClickSave}

                  />
                )}
                {selectedOptionForNewPatient == 1 && (
                  <>
                    <PatientForm
                      handleOnClickSave={props.handleOnClickSave}
                      fromSuperDtrf={props.fromSuperDtrf}
                      fromDtrfFront={props.fromDtrfFront}
                      resetFields={resetFields}
                      setResetFields={setResetFields}
                      patient={selectedPatient}
                      handleOnClickPrevious={handleOnClickPrevious}
                      previousStep={props.previousStep}
                      handleOnClickNext={handleOnClickNext}
                      new={true}
                      formValues={props.formValues}
                      contactNumber={contactNumber}

                    />
                  </>
                )}
              </div>
              {/* )} */}


            </fieldset>

          </div>

        </div>
        <div className="row">
          <hr></hr>
          <h4>Sample Info</h4>
          <hr></hr>
          {
            containers && testList.map((test, id) => (
              // testList.map((test, id) => (
              <div className="customWrap mb-2">
                <div>
                  <h6>{test.test_name}</h6>
                </div>
                <Formik
                  innerRef={multipleFormRef[id]}
                  initialValues={{
                    address: collectionLocation ? collectionLocation[id].location.address : "",
                    pinCode: collectionLocation ? collectionLocation[id].location.pinCode : "",
                    instituteLocation: collectionLocation && collectionLocation[id].location.hasOwnProperty("institute") ? ["yes"] : "",
                    city: collectionLocation ? collectionLocation[id].location.city : "",
                    state: collectionLocation ? collectionLocation[id].location.state : ""
                    ,
                  }}
                  validate={(values) => {
                    const errors = {};
                    if (props.fromDtrfFront) {
                      if (test.pcpndt) {
                        if (values.instituteLocation != 'yes') {
                          if (!values.address) {
                            errors.address = "Required"
                          }
                          if (!values.pinCode) {
                            errors.pinCode = "Required";
                          }
                          else if (!Number(values.pinCode)) {
                            errors.pinCode = "Should be Number";
                          }
                          if (!values.city) {
                            errors.city = "Reqruied"
                          }
                          if (!values.state) {
                            errors.state = "Required"
                          }

                        }
                      }
                    }

                    return errors
                  }}
                  onSubmit={(values, { setSubmitting }) => {
                    if (test.pcpndt) {
                      if (values.instituteLocation != "yes") {
                        const location = {
                          city: values.city,
                          state: values.state,
                          address: values.address,
                          pinCode: values.pinCode,
                          id: props.formValues.test_info.selectedTests[id]._id
                        }
                        collectionLocation[id].location = location
                        setCollectionLocation(collectionLocation)
                      }
                      else {
                        const location = { institute: "Institute" }
                        collectionLocation[id].location = location
                      }
                    }
                  }}>
                  {

                    ({ values }) => (
                      <Form >

                        <>
                          <div className="row">
                            <div className="col-12 col-md-6 form-group">
                              <label>
                                Sample Container Id<span className="marked">*</span>
                              </label>
                              <input
                                type="text"
                                name={id}
                                value={containerId[id].value}
                                placeholder="Enter Sample Container id (minimum 5 characters)"
                                className="form-control"
                                onChange={(value) => handleCytoContainerIdChange(value, id)}
                              />
                              {(containerIdErrors[id]) && (
                                <div className="formErr">Required</div>
                              )}
                              {
                                containerIdValidationList[id] && (
                                  <div className="formErr">Id should have more than 4 characters </div>
                                )
                              }
                            </div>

                            <div className="col-8 col-md-4 form-group">
                              <label>
                                Sample Container Type<span className="marked">*</span>
                              </label>

                              {containers[id] ?
                                <Select
                                  name={id}
                                  getOptionLabel={(e) => `${e.label}`}
                                  getOptionValue={(e) => `${e.value}`}
                                  options={containers[id]}
                                  value={selectedContainerType[id]}
                                  onChange={(value) => handleContainerTypeChange(value, id)}
                                  name="referenceDoctorState"
                                />
                                :
                                <label>
                                  Containers Not Found
                                </label>
                              }


                              <ErrorMessage
                                name="sampleContainerType"
                                component="div"
                                className="formErr"
                              />
                              {containerTypeErrors[id] && (
                                <div className="formErr">Required</div>
                              )}
                            </div>
                            <div className="col-4 col-md-2 form-group">
                              <div className="row mt-1">
                                <div className="col-md-12 col-12 text-left mt-4">
                                  <button
                                    name={id}
                                    type="button"
                                    className="btn btn-primary"
                                    onClick={() => handleCytoAddContainerID(id)}
                                  >
                                    Add
                                  </button>
                                </div>
                              </div>
                            </div>

                            <div className="col-10 col-md-8 form-group">
                              {sampleContainerList[id].containers.map((test, container_id) => (
                                <>
                                  <div className="row mb-1">
                                    <div className="col-10">
                                      <div className="form-group mb-0">
                                        <label className="form-control" style={{ height: "auto" }}>{test.type}: {test.id}</label>
                                      </div>
                                    </div>
                                    <div className="col-2  text-left">
                                      <div style={{ padding: "5px 20px" }}>
                                        <button
                                          name={id}
                                          type="button"
                                          className="btn btn-primary"
                                          onClick={() =>
                                            handleCytoRemoveContainerId(id, container_id)
                                          }
                                        >
                                          remove
                                        </button>
                                      </div>
                                    </div>
                                  </div>
                                </>
                              ))}
                            </div>
                          </div>

                          {test.pcpndt &&
                            <>
                              <h6>PCPNDT Info</h6>
                              <hr></hr>
                              <div className="mb-3">
                                <input type="file"
                                  ref={pcpndtReference[id]}
                                  accept="image/*,application/pdf"
                                  style={{ display: 'none' }}
                                  className="form-control"
                                  onChange={(files) => uploadPcpndtScans(files, id)}
                                  multiple />
                              </div>
                              <div className="row">
                                <div className="col-md-6 col-12">
                                  <div className="form-group" style={{ display: "flex" }}>
                                    <Field ref={instituteLocationRef[id]} type="checkbox" name="instituteLocation" value="yes" />
                                    <label className="mb-3 ml-3">
                                      Sample pickup location is same as institute location <span className="marked">*</span>
                                    </label>
                                    <br />
                                    <ErrorMessage
                                      name="instituteLocation"
                                      component="div"
                                      className="formErr"
                                    />
                                  </div>
                                </div>
                              </div>
                              <div className="row">
                                <label>
                                  Location <span className="marked">*</span>
                                </label>
                              </div>
                              <div className="row">
                                <TextField
                                  title="Address"
                                  name="address"
                                  mandatory={true}
                                  component="textarea"
                                  isDisabled={values.instituteLocation == "yes" ? true : false}
                                />
                                <TextField
                                  title="Pin Code"
                                  name="pinCode"
                                  mandatory={true}
                                  isDisabled={values.instituteLocation == "yes" ? true : false}
                                />

                                <div className="col-md-6 col-12">
                                  <div className="form-group">
                                    <label>
                                      City <span className="marked">*</span>
                                    </label>


                                    <MySelect
                                      isMulti={false}
                                      optionList={cityList}
                                      name="city"
                                      isDisabled={values.instituteLocation == 'yes' ? true : false}

                                    />
                                    <ErrorMessage
                                      name="city"
                                      component="div"
                                      className="formErr"
                                    />

                                  </div>

                                </div>
                                <div className="col-md-6 col-12">
                                  <div className="form-group">
                                    <label>
                                      State <span className="marked">*</span>
                                    </label>

                                    <MySelect
                                      isMulti={false}
                                      optionList={stateList}
                                      name="state"
                                      isDisabled={values.instituteLocation == 'yes' ? true : false}
                                    />
                                    <ErrorMessage
                                      name="state"
                                      component="div"
                                      className="formErr"
                                    />

                                  </div>
                                </div>
                                <div className="col-4 col-md-4 form-group">
                                  <div className="row mt-1">
                                    <div className="text-right mt-4">
                                      <button
                                        htmlFor="files"
                                        type="button"
                                        className="btn btn-primary"
                                        onClick={() => handleUploadScansClick(id)}
                                      >
                                        Upload Scans
                                      </button>
                                    </div>
                                  </div>
                                </div>
                              </div>

                              <div className="col-10 col-md-8 form-group">
                                {props.fileUpload.pcpndtFiles[id].scans.map((name, container_id) => (
                                  <>
                                    <div className="row mb-1">
                                      <div className="col-10">
                                        <div className="form-control mb-0">
                                          <svg xmlns="http://www.w3.org/2000/svg" width="24" height="24" viewBox="0 0 24 24" fill="none" stroke="currentColor" stroke-width="2" stroke-linecap="round" stroke-linejoin="round" class="feather feather-file"><path d="M13 2H6a2 2 0 0 0-2 2v16a2 2 0 0 0 2 2h12a2 2 0 0 0 2-2V9z"></path><polyline points="13 2 13 9 20 9"></polyline></svg>
                                          <label className="ml-2" style={{ fontSize: "12px" }}>{name.name ? name.name : name.displayName ? name.displayName : name.originalname}</label>
                                        </div>
                                      </div>
                                      <CancelOutlinedIcon size="medium" onClick={e => onRemovePcpndt(id, container_id)} />
                                    </div>
                                  </>
                                ))}
                              </div>
                            </>}
                        </>
                      </Form>)}
                </Formik>
              </div>
            ))
          }
        </div>
        {
          props.fromSuperDtrf && <>
            {(!selectedPatient && selectedOptionForNewPatient != 1) &&
              <div className="row">
                <div className="col-md-2 col-2 text-left">
                  <div style={{ padding: "5px 20px" }}>
                    <button
                      onClick={e => Router.push("/super-dtrf")}
                      className="btn btn-primary mr-2"
                    >
                      Exit
                    </button>
                  </div>
                </div>
                <div className="col-md-10 col-6 text-reft ">
                  <div className="formButttonCenter">
                    <button
                      onClick={handleOnClickPrevious}
                      className="btn btn-primary mr-2"
                    >
                      Previous
                    </button>
                    {!props.Token.isComplete &&

                      <button
                        type="button"
                        onClick={() =>
                          handleOnClickSave()
                        }
                        className="btn btn-primary mr-2"
                      >
                        Save
                      </button>
                    }
                    <button
                      onClick={handleOnClickTest}
                      className="btn btn-primary mr-2"
                    >
                      Next
                    </button>
                  </div>
                </div>

              </div>
            }
          </>
        }
        {props.fromDtrfFront && <>

          {(!selectedPatient && selectedOptionForNewPatient != 1) &&
            <div className="row">
              <div className="col-md-12 col-12 text-right">
                <div className="formButttonCenter">
                  <button
                    onClick={handleOnClickPrevious}
                    className="btn btn-primary mr-2"
                  >
                    Previous
                  </button>
                </div>
              </div>
            </div>
          }
        </>
        }

      </div>
    </>
  );
};
const mapStateToProps = state => ({
  patient_details: state.formData.formData.patient_details ? state.formData.formData.patient_details : null,
  formDataRedux: state.formData.formData,
  Token: state.Token,
})

export default connect(mapStateToProps, { getPatient_details, setFormData, getPcpndtFiles })(PatientDetails);
